# DataExchange
TKVRML
VrmlData

# VrmlData_Node Class Reference

`#include <VrmlData_Node.hxx>`

Inheritance diagram for VrmlData_Node:

[legend]

## Public Member Functions

Standard_EXPORT | VrmlData_Node ()
virtual | ~VrmlData_Node ()
const VrmlData_Scene & | Scene () const
const char * | Name () const
Standard_EXPORT VrmlData_ErrorStatus | ReadNode (VrmlData_InBuffer &theBuffer, Handle(VrmlData_Node)&theNode, const Handle(Standard_Type)&Type=NULL)
virtual Standard_EXPORT VrmlData_ErrorStatus | Read (VrmlData_InBuffer &theBuffer)=0
virtual Standard_EXPORT VrmlData_ErrorStatus | Write (const char *thePrefix) const
virtual Standard_EXPORT Standard_Boolean | IsDefault () const
Standard_EXPORT VrmlData_ErrorStatus | WriteClosing () const
virtual Standard_EXPORT | Handle (VrmlData_Node) Clone(const Handle(VrmlData_Node)&) const

## Static Public Member Functions

static Standard_EXPORT VrmlData_ErrorStatus | ReadBoolean (VrmlData_InBuffer &theBuffer, Standard_Boolean &theResult)
static Standard_EXPORT VrmlData_ErrorStatus | ReadString (VrmlData_InBuffer &theBuffer, TCollection_AsciiString &theRes)
static Standard_EXPORT VrmlData_ErrorStatus | ReadMultiString (VrmlData_InBuffer &theBuffer, NCollection_List< TCollection_AsciiString > &theRes)
static Standard_EXPORT VrmlData_ErrorStatus | ReadInteger (VrmlData_InBuffer &theBuffer, long &theResult)
static Standard_Boolean | OK (const VrmlData_ErrorStatus theStat)
static Standard_Boolean | OK (VrmlData_ErrorStatus &outStat, const VrmlData_ErrorStatus theStat)
static Standard_Integer | GlobalIndent ()

## Protected Member Functions

Standard_EXPORT | VrmlData_Node (const VrmlData_Scene &theScene, const char *theName)

## Static Protected Member Functions

static Standard_EXPORT VrmlData_ErrorStatus | readBrace (VrmlData_InBuffer &theBuffer)

## Private Member Functions

Standard_EXPORT void | setName (const char *theName, const char *theSuffix=0L)

## Private Attributes

const VrmlData_Scene * | myScene
const char * | myName
| name of the node

## Detailed Description

Abstract VRML Node

## Constructor & Destructor Documentation

Standard_EXPORT VrmlData_Node::VrmlData_Node | ( |  | ) |

| Empty constructor

virtual VrmlData_Node::~VrmlData_Node | ( |  | ) | `[inline, virtual]`

| Destructor

Standard_EXPORT VrmlData_Node::VrmlData_Node | ( | const VrmlData_Scene & | theScene,
|  | const char * | theName
| ) | `[protected]`

| Constructor

## Member Function Documentation

static Standard_Integer VrmlData_Node::GlobalIndent | ( |  | ) | `[inline, static]`

| Define the common Indent in spaces, for writing all nodes.

virtual Standard_EXPORT VrmlData_Node::Handle | ( | VrmlData_Node |  | ) | const`[virtual]`

Create a copy of this node. If the parameter is null, a new copied node is created. Otherwise new node is not created, but rather the given one is modified.

This method nullifies the argument node if its member myScene differs from that one of the current instance.

Reimplemented in VrmlData_Appearance, VrmlData_Box, VrmlData_Color, VrmlData_Cone, VrmlData_Coordinate, VrmlData_Cylinder, VrmlData_Group, VrmlData_Group, VrmlData_Group, VrmlData_ImageTexture, VrmlData_IndexedFaceSet, VrmlData_IndexedLineSet, VrmlData_Material, VrmlData_Normal, VrmlData_ShapeNode, VrmlData_Sphere, VrmlData_TextureCoordinate, and VrmlData_WorldInfo.

virtual Standard_EXPORT Standard_Boolean VrmlData_Node::IsDefault | ( |  | ) | const`[virtual]`

| Returns True if the node is default, then it would not be written. Reimplemented in VrmlData_Appearance, VrmlData_ArrayVec3d, VrmlData_IndexedFaceSet, VrmlData_IndexedLineSet, VrmlData_Material, VrmlData_ShapeNode, VrmlData_UnknownNode, and VrmlData_WorldInfo.

const char* VrmlData_Node::Name | ( |  | ) | const`[inline]`

| Query the name

static Standard_Boolean VrmlData_Node::OK | ( | VrmlData_ErrorStatus & | outStat,
|  | const VrmlData_ErrorStatus | theStat
| ) | `[inline, static]`

static Standard_Boolean VrmlData_Node::OK | ( | const VrmlData_ErrorStatus | theStat | ) | `[inline, static]`

virtual Standard_EXPORT VrmlData_ErrorStatus VrmlData_Node::Read | ( | VrmlData_InBuffer & | theBuffer | ) | `[pure virtual]`

| Read the Node from input stream. Implemented in VrmlData_Appearance, VrmlData_Box, VrmlData_Color, VrmlData_Cone, VrmlData_Coordinate, VrmlData_Cylinder, VrmlData_Group, VrmlData_ImageTexture, VrmlData_IndexedFaceSet, VrmlData_IndexedLineSet, VrmlData_Material, VrmlData_Normal, VrmlData_ShapeNode, VrmlData_Sphere, VrmlData_TextureCoordinate, VrmlData_UnknownNode, and VrmlData_WorldInfo.

static Standard_EXPORT VrmlData_ErrorStatus VrmlData_Node::ReadBoolean | ( | VrmlData_InBuffer & | theBuffer,
|  | Standard_Boolean & | theResult
| ) | `[static]`

| Read one boolean value (TRUE or FALSE).

static Standard_EXPORT VrmlData_ErrorStatus VrmlData_Node::readBrace | ( | VrmlData_InBuffer & | theBuffer | ) | `[static, protected]`

| Read the closing brace. If successful, theBufrfer is incremented. If no brace is found, theBuffer stays in untouched and the method returns VrmlFormatError.

static Standard_EXPORT VrmlData_ErrorStatus VrmlData_Node::ReadInteger | ( | VrmlData_InBuffer & | theBuffer,
|  | long & | theResult
| ) | `[static]`

| Read one integer value.

static Standard_EXPORT VrmlData_ErrorStatus VrmlData_Node::ReadMultiString | ( | VrmlData_InBuffer & | theBuffer,
|  | NCollection_List< TCollection_AsciiString > & | theRes
| ) | `[static]`

| Read one quoted string, the quotes are removed.

Standard_EXPORT VrmlData_ErrorStatus VrmlData_Node::ReadNode | ( | VrmlData_InBuffer & | theBuffer,
|  | Handle(VrmlData_Node)& | theNode,
|  | const Handle(Standard_Type)& | Type = `NULL`
| ) |

Read a complete node definition from VRML stream

Parameters:

  | theBuffer | Buffer receiving the input data.
  | theNode | `[out]` Node restored from the buffer data
  | Type | Node type to be checked. If it is NULL(default) no type checking is done. Otherwise the created node is matched and an error is returned if no match detected.

static Standard_EXPORT VrmlData_ErrorStatus VrmlData_Node::ReadString | ( | VrmlData_InBuffer & | theBuffer,
|  | TCollection_AsciiString & | theRes
| ) | `[static]`

| Read one quoted string, the quotes are removed.

const VrmlData_Scene& VrmlData_Node::Scene | ( |  | ) | const`[inline]`

| Query the Scene that contains this Node

Standard_EXPORT void VrmlData_Node::setName | ( | const char * | theName,
|  | const char * | theSuffix = `0L`
| ) | `[private]`

| Method called from VrmlData_Scene when a name should be assigned automatically.

virtual Standard_EXPORT VrmlData_ErrorStatus VrmlData_Node::Write | ( | const char * | thePrefix | ) | const`[virtual]`

| Write the Node to output stream. Reimplemented in VrmlData_Appearance, VrmlData_Box, VrmlData_Color, VrmlData_Cone, VrmlData_Coordinate, VrmlData_Cylinder, VrmlData_Group, VrmlData_IndexedFaceSet, VrmlData_IndexedLineSet, VrmlData_Material, VrmlData_Normal, VrmlData_ShapeNode, VrmlData_Sphere, and VrmlData_WorldInfo.

Standard_EXPORT VrmlData_ErrorStatus VrmlData_Node::WriteClosing | ( |  | ) | const

| Write the closing brace in the end of a node output.

## Field Documentation

const char* VrmlData_Node::myName `[private]`

const VrmlData_Scene* VrmlData_Node::myScene `[private]`

The documentation for this class was generated from the following file:

- VrmlData_Node.hxx